package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface AuthorizationGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void getExplicitResourcePermissions( int resourceId, AsyncCallback<java.util.Set<org.rhq.core.domain.authz.Permission>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void getImplicitResourcePermissions( int resourceId, AsyncCallback<java.util.Set<org.rhq.core.domain.authz.Permission>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void getExplicitGroupPermissions( int groupId, AsyncCallback<java.util.Set<org.rhq.core.domain.authz.Permission>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void getImplicitGroupPermissions( int groupId, AsyncCallback<java.util.Set<org.rhq.core.domain.authz.Permission>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void getExplicitGlobalPermissions( AsyncCallback<java.util.Set<org.rhq.core.domain.authz.Permission>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService
     */
    void hasResourcePermission( org.rhq.core.domain.authz.Permission permission, java.util.Collection<java.lang.Integer> resourceIds, AsyncCallback<java.lang.Boolean> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static AuthorizationGWTServiceAsync instance;

        public static final AuthorizationGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (AuthorizationGWTServiceAsync) GWT.create( AuthorizationGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "AuthorizationGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
