package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ClusterGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService
     */
    void createAutoClusterBackingGroup( org.rhq.core.domain.resource.group.ClusterKey clusterKey, boolean addResources, AsyncCallback<org.rhq.core.domain.resource.group.ResourceGroup> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService
     */
    void getAutoClusterBackingGroup( org.rhq.core.domain.resource.group.ClusterKey clusterKey, AsyncCallback<org.rhq.core.domain.resource.group.ResourceGroup> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService
     */
    void getAutoClusterResources( org.rhq.core.domain.resource.group.ClusterKey clusterKey, AsyncCallback<java.util.List<org.rhq.core.domain.resource.Resource>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService
     */
    void getClusterTree( int groupId, AsyncCallback<org.rhq.core.domain.resource.group.composite.ClusterFlyweight> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ClusterGWTServiceAsync instance;

        public static final ClusterGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ClusterGWTServiceAsync) GWT.create( ClusterGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ClusterGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
