package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface LdapGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService
     */
    void findAvailableGroups( AsyncCallback<java.util.Set<java.util.Map<java.lang.String,java.lang.String>>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService
     */
    void getLdapDetailsFor( java.lang.String user, AsyncCallback<java.util.Map<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService
     */
    void setLdapGroupsForRole( int roleId, java.util.List<java.lang.String> groupIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService
     */
    void findLdapGroupsAssignedToRole( int currentRoleId, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.LdapGroup>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService
     */
    void checkLdapConfiguredStatus( AsyncCallback<java.lang.Boolean> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static LdapGWTServiceAsync instance;

        public static final LdapGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (LdapGWTServiceAsync) GWT.create( LdapGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "LdapGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
