package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface RoleGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void findRolesByCriteria( org.rhq.core.domain.criteria.RoleCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.authz.Role>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void createRole( org.rhq.core.domain.authz.Role role, AsyncCallback<org.rhq.core.domain.authz.Role> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void updateRole( org.rhq.core.domain.authz.Role role, AsyncCallback<org.rhq.core.domain.authz.Role> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void removeRoles( int[] roleIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void setAssignedResourceGroups( int roleId, int[] resourceGroupIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void setAssignedSubjects( int roleId, int[] subjectIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService
     */
    void setAssignedRolesForSubject( int subjectId, int[] roleIds, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static RoleGWTServiceAsync instance;

        public static final RoleGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (RoleGWTServiceAsync) GWT.create( RoleGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "RoleGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
